SDL_rwops.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_rwops.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_RWops

## Macros

#define | SDL_RWOPS_UNKNOWN 0U
#define | SDL_RWOPS_WINFILE 1U
#define | SDL_RWOPS_STDFILE 2U
#define | SDL_RWOPS_JNIFILE 3U
#define | SDL_RWOPS_MEMORY 4U
#define | SDL_RWOPS_MEMORY_RO 5U

## Functions

Read endian functions
Read an item of the specified endianness and return in native format.
Uint8 | SDL_ReadU8 (SDL_RWops *src)
Uint16 | SDL_ReadLE16 (SDL_RWops *src)
Uint16 | SDL_ReadBE16 (SDL_RWops *src)
Uint32 | SDL_ReadLE32 (SDL_RWops *src)
Uint32 | SDL_ReadBE32 (SDL_RWops *src)
Uint64 | SDL_ReadLE64 (SDL_RWops *src)
Uint64 | SDL_ReadBE64 (SDL_RWops *src)
Write endian functions
Write an item of native format to the specified endianness.
size_t | SDL_WriteU8 (SDL_RWops *dst, Uint8 value)
size_t | SDL_WriteLE16 (SDL_RWops *dst, Uint16 value)
size_t | SDL_WriteBE16 (SDL_RWops *dst, Uint16 value)
size_t | SDL_WriteLE32 (SDL_RWops *dst, Uint32 value)
size_t | SDL_WriteBE32 (SDL_RWops *dst, Uint32 value)
size_t | SDL_WriteLE64 (SDL_RWops *dst, Uint64 value)
size_t | SDL_WriteBE64 (SDL_RWops *dst, Uint64 value)

## RWFrom functions

Functions to create SDL_RWops structures from various data streams.
#define | RW_SEEK_SET 0
#define | RW_SEEK_CUR 1
#define | RW_SEEK_END 2
SDL_RWops * | SDL_RWFromFile (const char *file, const char *mode)
SDL_RWops * | SDL_RWFromFP (FILE *fp, SDL_bool autoclose)
SDL_RWops * | SDL_RWFromMem (void *mem, int size)
SDL_RWops * | SDL_RWFromConstMem (const void *mem, int size)
SDL_RWops * | SDL_AllocRW (void)
void | SDL_FreeRW (SDL_RWops *area)
Sint64 | SDL_RWsize (SDL_RWops *context)
Sint64 | SDL_RWseek (SDL_RWops *context, Sint64 offset, int whence)
Sint64 | SDL_RWtell (SDL_RWops *context)
size_t | SDL_RWread (SDL_RWops *context, void *ptr, size_t size, size_t maxnum)
size_t | SDL_RWwrite (SDL_RWops *context, const void *ptr, size_t size, size_t num)
int | SDL_RWclose (SDL_RWops *context)
void * | SDL_LoadFile_RW (SDL_RWops *src, size_t *datasize, int freesrc)
void * | SDL_LoadFile (const char *file, size_t *datasize)

## Macro Definition Documentation

## RW_SEEK_CUR

#define RW_SEEK_CUR 1

Seek relative to current read point

Definition at line 373 of file SDL_rwops.h.

## RW_SEEK_END

#define RW_SEEK_END 2

Seek relative to the end of data

Definition at line 374 of file SDL_rwops.h.

## RW_SEEK_SET

#define RW_SEEK_SET 0

Seek from the beginning of data

Definition at line 372 of file SDL_rwops.h.

## SDL_RWOPS_JNIFILE

#define SDL_RWOPS_JNIFILE 3U

Android asset

Definition at line 47 of file SDL_rwops.h.

## SDL_RWOPS_MEMORY

#define SDL_RWOPS_MEMORY 4U

Memory stream

Definition at line 48 of file SDL_rwops.h.

## SDL_RWOPS_MEMORY_RO

#define SDL_RWOPS_MEMORY_RO 5U

Read-Only memory stream

Definition at line 49 of file SDL_rwops.h.

## SDL_RWOPS_STDFILE

#define SDL_RWOPS_STDFILE 2U

Stdio file

Definition at line 46 of file SDL_rwops.h.

## SDL_RWOPS_UNKNOWN

#define SDL_RWOPS_UNKNOWN 0U

# CategoryRWOPS

This file provides a general interface for SDL to read and write data streams. It can easily be extended to files, memory, etc. Unknown stream type

Definition at line 44 of file SDL_rwops.h.

## SDL_RWOPS_WINFILE

#define SDL_RWOPS_WINFILE 1U

Win32 file

Definition at line 45 of file SDL_rwops.h.

## Function Documentation

## SDL_AllocRW()

SDL_RWops * SDL_AllocRW | ( | void |  | ) |

extern

Use this function to allocate an empty, unpopulated SDL_RWops structure.

Applications do not need to use this function unless they are providing their own SDL_RWops implementation. If you just need a SDL_RWops to read/write a common data source, you should use the built-in implementations in SDL, like SDL_RWFromFile() or SDL_RWFromMem(), etc.

You must free the returned pointer with SDL_FreeRW(). Depending on your operating system and compiler, there may be a difference between the malloc() and free() your program uses and the versions SDL calls internally. Trying to mix the two can cause crashing such as segmentation faults. Since all SDL_RWops must free themselves when their close method is called, all SDL_RWops must be allocated through this function, so they can all be freed correctly with SDL_FreeRW().

Returns
  a pointer to the allocated memory on success, or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FreeRW

## SDL_FreeRW()

void SDL_FreeRW | ( | SDL_RWops * | area | ) |

extern

Use this function to free an SDL_RWops structure allocated by SDL_AllocRW().

Applications do not need to use this function unless they are providing their own SDL_RWops implementation. If you just need a SDL_RWops to read/write a common data source, you should use the built-in implementations in SDL, like SDL_RWFromFile() or SDL_RWFromMem(), etc, and call the close method on those SDL_RWops pointers when you are done with them.

Only use SDL_FreeRW() on pointers returned by SDL_AllocRW(). The pointer is invalid as soon as this function returns. Any extra memory allocated during creation of the SDL_RWops is not freed by SDL_FreeRW(); the programmer must be responsible for managing that memory in their close method.

Parameters

  area | the SDL_RWops structure to be freed.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_AllocRW

## SDL_LoadFile()

void * SDL_LoadFile | ( | const char * | file,
|  | size_t * | datasize )

extern

Load all the data from a file path.

The data is allocated with a zero byte at the end (null terminated) for convenience. This extra byte is not included in the value reported via datasize.

The data should be freed with SDL_free().

Prior to SDL 2.0.10, this function was a macro wrapping around SDL_LoadFile_RW.

Parameters

  file | the path to read all available data from.
  datasize | if not NULL, will store the number of bytes read.

Returns
  the data, or NULL if there was an error.

Since
  This function is available since SDL 2.0.10.

## SDL_LoadFile_RW()

void * SDL_LoadFile_RW | ( | SDL_RWops * | src,
|  | size_t * | datasize,
|  | int | freesrc )

extern

Load all the data from an SDL data stream.

The data is allocated with a zero byte at the end (null terminated) for convenience. This extra byte is not included in the value reported via datasize.

The data should be freed with SDL_free().

Parameters

  src | the SDL_RWops to read all available data from.
  datasize | if not NULL, will store the number of bytes read.
  freesrc | if non-zero, calls SDL_RWclose() on src before returning.

Returns
  the data, or NULL if there was an error.

Since
  This function is available since SDL 2.0.6.

## SDL_ReadBE16()

Uint16 SDL_ReadBE16 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 16 bits of big-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  16 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadLE16

## SDL_ReadBE32()

Uint32 SDL_ReadBE32 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 32 bits of big-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  32 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadLE32

## SDL_ReadBE64()

Uint64 SDL_ReadBE64 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 64 bits of big-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  64 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadLE64

## SDL_ReadLE16()

Uint16 SDL_ReadLE16 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 16 bits of little-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  16 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadBE16

## SDL_ReadLE32()

Uint32 SDL_ReadLE32 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 32 bits of little-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  32 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadBE32

## SDL_ReadLE64()

Uint64 SDL_ReadLE64 | ( | SDL_RWops * | src | ) |

extern

Use this function to read 64 bits of little-endian data from an SDL_RWops and return in native format.

SDL byteswaps the data only if necessary, so the data returned will be in the native byte order.

Parameters

  src | the stream from which to read data.

Returns
  64 bits of data in the native byte order of the platform.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadBE64

## SDL_ReadU8()

Uint8 SDL_ReadU8 | ( | SDL_RWops * | src | ) |

extern

Use this function to read a byte from an SDL_RWops.

Parameters

  src | the SDL_RWops to read from.

Returns
  the read byte on success or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteU8

## SDL_RWclose()

int SDL_RWclose | ( | SDL_RWops * | context | ) |

extern

Close and free an allocated SDL_RWops structure.

SDL_RWclose() closes and cleans up the SDL_RWops stream. It releases any resources used by the stream and frees the SDL_RWops itself with SDL_FreeRW(). This returns 0 on success, or -1 if the stream failed to flush to its output (e.g. to disk).

Note that if this fails to flush the stream to disk, this function reports an error, but the SDL_RWops is still invalid once this function returns.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | SDL_RWops structure to close.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek
  SDL_RWwrite

## SDL_RWFromConstMem()

SDL_RWops * SDL_RWFromConstMem | ( | const void * | mem,
|  | int | size )

extern

Use this function to prepare a read-only memory buffer for use with RWops.

This function sets up an SDL_RWops struct based on a memory area of a certain size. It assumes the memory area is not writable.

Attempting to write to this RWops stream will report an error without writing to the memory buffer.

This memory buffer is not copied by the RWops; the pointer you provide must remain valid until you close the stream. Closing the stream will not free the original buffer.

If you need to write to a memory buffer, you should use SDL_RWFromMem() with a writable buffer of memory instead.

Parameters

  mem | a pointer to a read-only buffer to feed an SDL_RWops stream.
  size | the buffer size, in bytes.

Returns
  a pointer to a new SDL_RWops structure, or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek
  SDL_RWtell

## SDL_RWFromFile()

SDL_RWops * SDL_RWFromFile | ( | const char * | file,
|  | const char * | mode )

extern

Use this function to create a new SDL_RWops structure for reading from and/or writing to a named file.

The mode string is treated roughly the same as in a call to the C library's fopen(), even if SDL doesn't happen to use fopen() behind the scenes.

Available mode strings:

- "r": Open a file for reading. The file must exist.
- "w": Create an empty file for writing. If a file with the same name already exists its content is erased and the file is treated as a new empty file.
- "a": Append to a file. Writing operations append data at the end of the file. The file is created if it does not exist.
- "r+": Open a file for update both reading and writing. The file must exist.
- "w+": Create an empty file for both reading and writing. If a file with the same name already exists its content is erased and the file is treated as a new empty file.
- "a+": Open a file for reading and appending. All writing operations are performed at the end of the file, protecting the previous content to be overwritten. You can reposition (fseek, rewind) the internal pointer to anywhere in the file for reading, but writing operations will move it back to the end of file. The file is created if it does not exist.

NOTE: In order to open a file as a binary file, a "b" character has to be included in the mode string. This additional "b" character can either be appended at the end of the string (thus making the following compound modes: "rb", "wb", "ab", "r+b", "w+b", "a+b") or be inserted between the letter and the "+" sign for the mixed modes ("rb+", "wb+", "ab+"). Additional characters may follow the sequence, although they should have no effect. For example, "t" is sometimes appended to make explicit the file is a text file.

This function supports Unicode filenames, but they must be encoded in UTF-8 format, regardless of the underlying operating system.

As a fallback, SDL_RWFromFile() will transparently open a matching filename in an Android app's assets.

Closing the SDL_RWops will close the file handle SDL is holding internally.

Parameters

  file | a UTF-8 string representing the filename to open.
  mode | an ASCII string representing the mode to be used for opening the file.

Returns
  a pointer to the SDL_RWops structure that is created, or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek
  SDL_RWtell
  SDL_RWwrite

## SDL_RWFromFP()

SDL_RWops * SDL_RWFromFP | ( | FILE * | fp,
|  | SDL_bool | autoclose )

extern

## SDL_RWFromMem()

SDL_RWops * SDL_RWFromMem | ( | void * | mem,
|  | int | size )

extern

Use this function to prepare a read-write memory buffer for use with SDL_RWops.

This function sets up an SDL_RWops struct based on a memory area of a certain size, for both read and write access.

This memory buffer is not copied by the RWops; the pointer you provide must remain valid until you close the stream. Closing the stream will not free the original buffer.

If you need to make sure the RWops never writes to the memory buffer, you should use SDL_RWFromConstMem() with a read-only buffer of memory instead.

Parameters

  mem | a pointer to a buffer to feed an SDL_RWops stream.
  size | the buffer size, in bytes.

Returns
  a pointer to a new SDL_RWops structure, or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek
  SDL_RWtell
  SDL_RWwrite

## SDL_RWread()

size_t SDL_RWread | ( | SDL_RWops * | context,
|  | void * | ptr,
|  | size_t | size,
|  | size_t | maxnum )

extern

Read from a data source.

This function reads up to maxnum objects each of size size from the data source to the area pointed at by ptr. This function may read less objects than requested. It will return zero when there has been an error or the data stream is completely read.

SDL_RWread() is actually a function wrapper that calls the SDL_RWops's read method appropriately, to simplify application development.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | a pointer to an SDL_RWops structure.
  ptr | a pointer to a buffer to read data into.
  size | the size of each object to read, in bytes.
  maxnum | the maximum number of objects to be read.

Returns
  the number of objects read, or 0 at error or end of file; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWseek
  SDL_RWwrite

## SDL_RWseek()

Sint64 SDL_RWseek | ( | SDL_RWops * | context,
|  | Sint64 | offset,
|  | int | whence )

extern

Seek within an SDL_RWops data stream.

This function seeks to byte offset, relative to whence.

whence may be any of the following values:

- RW_SEEK_SET: seek from the beginning of data
- RW_SEEK_CUR: seek relative to current read point
- RW_SEEK_END: seek relative to the end of data

If this stream can not seek, it will return -1.

SDL_RWseek() is actually a wrapper function that calls the SDL_RWops's seek method appropriately, to simplify application development.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | a pointer to an SDL_RWops structure.
  offset | an offset in bytes, relative to whence location; can be negative.
  whence | any of RW_SEEK_SET, RW_SEEK_CUR, RW_SEEK_END.

Returns
  the final offset in the data stream after the seek or -1 on error.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWtell
  SDL_RWwrite

## SDL_RWsize()

Sint64 SDL_RWsize | ( | SDL_RWops * | context | ) |

extern

Use this function to get the size of the data stream in an SDL_RWops.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | the SDL_RWops to get the size of the data stream from.

Returns
  the size of the data stream in the SDL_RWops on success, -1 if unknown or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.10.

## SDL_RWtell()

Sint64 SDL_RWtell | ( | SDL_RWops * | context | ) |

extern

Determine the current read/write offset in an SDL_RWops data stream.

SDL_RWtell is actually a wrapper function that calls the SDL_RWops's seek method, with an offset of 0 bytes from RW_SEEK_CUR, to simplify application development.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | a SDL_RWops data stream object from which to get the current offset.

Returns
  the current offset in the stream, or -1 if the information can not be determined.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek
  SDL_RWwrite

## SDL_RWwrite()

size_t SDL_RWwrite | ( | SDL_RWops * | context,
|  | const void * | ptr,
|  | size_t | size,
|  | size_t | num )

extern

Write to an SDL_RWops data stream.

This function writes exactly num objects each of size size from the area pointed at by ptr to the stream. If this fails for any reason, it'll return less than num to demonstrate how far the write progressed. On success, it returns num.

SDL_RWwrite is actually a function wrapper that calls the SDL_RWops's write method appropriately, to simplify application development.

Prior to SDL 2.0.10, this function was a macro.

Parameters

  context | a pointer to an SDL_RWops structure.
  ptr | a pointer to a buffer containing data to write.
  size | the size of an object to write, in bytes.
  num | the number of objects to write.

Returns
  the number of objects written, which will be less than num on error; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_RWclose
  SDL_RWFromConstMem
  SDL_RWFromFile
  SDL_RWFromFP
  SDL_RWFromMem
  SDL_RWread
  SDL_RWseek

## SDL_WriteBE16()

size_t SDL_WriteBE16 | ( | SDL_RWops * | dst,
|  | Uint16 | value )

extern

Use this function to write 16 bits in native format to a SDL_RWops as big-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in big-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteLE16

## SDL_WriteBE32()

size_t SDL_WriteBE32 | ( | SDL_RWops * | dst,
|  | Uint32 | value )

extern

Use this function to write 32 bits in native format to a SDL_RWops as big-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in big-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteLE32

## SDL_WriteBE64()

size_t SDL_WriteBE64 | ( | SDL_RWops * | dst,
|  | Uint64 | value )

extern

Use this function to write 64 bits in native format to a SDL_RWops as big-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in big-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteLE64

## SDL_WriteLE16()

size_t SDL_WriteLE16 | ( | SDL_RWops * | dst,
|  | Uint16 | value )

extern

Use this function to write 16 bits in native format to a SDL_RWops as little-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in little-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteBE16

## SDL_WriteLE32()

size_t SDL_WriteLE32 | ( | SDL_RWops * | dst,
|  | Uint32 | value )

extern

Use this function to write 32 bits in native format to a SDL_RWops as little-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in little-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteBE32

## SDL_WriteLE64()

size_t SDL_WriteLE64 | ( | SDL_RWops * | dst,
|  | Uint64 | value )

extern

Use this function to write 64 bits in native format to a SDL_RWops as little-endian data.

SDL byteswaps the data only if necessary, so the application always specifies native format, and the data written will be in little-endian format.

Parameters

  dst | the stream to which data will be written.
  value | the data to be written, in native format.

Returns
  1 on successful write, 0 on error.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_WriteBE64

## SDL_WriteU8()

size_t SDL_WriteU8 | ( | SDL_RWops * | dst,
|  | Uint8 | value )

extern

Use this function to write a byte to an SDL_RWops.

Parameters

  dst | the SDL_RWops to write to.
  value | the byte value to write.

Returns
  1 on success or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_ReadU8